var game = {
    loaderSeconds:          0,
    maxLoaderSeconds:       500,
    maskLevel:              5,
    goForTheRecordLevel:    6,
    lastLevel:              7,
    levelWithRedStars:      4,
    startConfig: function(){
        game.musicWasLooped = false;
        game.musicCurrentTime = 0;
        game.oldMusicCurrentTime = 0;
        game.level = 1;
        game.points = 0;
        game.sumOfPoints = 0;
        game.maskAnimationCurrentFrame = 1;
        game.maskAnimationFrames = 0;
        game.maskAnimationCounter = 0;
        game.maskSizePercent = 0;
        game.maskSizePercentIncreaser = 0;
        game.maskSizePercentVector = 1;
        game.goForTheRecordVector = 1;
        game.goForTheRecordOpacity = 0;
        game.goForTheRecordSpeed = 1;
        game.maskGlowOpacity = 0;
        game.lastStarOpacity = 0;
        game.animatedStars = [];
        game.particles =     [];
        game.mainScreenOpacity = 0;
        game.backgroundOpacity = 0;
        game.canShowClickableStars = false;
        game.canOverGame = false;
        game.isOver = false;
        game.goForTheRecordIsStarted = false;
        game.lastStarIsStarted = false;
        game.canShowGoForTheRecord = true;
        game.canShowLastStar = false;
    },
    isStarted: false,
    starsPerLevel: [10, 20, 30, 40, 0, 200000],
    // starsPerLevel: [1, 1, 1, 1, 0, 200000],
    musicParts: [{
        from: 0,
        to: (0 * 60) + 15.484
    },
    {
        from: (0 * 60) + 15.484,
        to: (0 * 60) + 42.902
    },
    {
        from: (0 * 60) + 42.902,
        to: (1 * 60) + 10.323
    },
    {
        from: (1 * 60) + 10.323,
        to: (2 * 60) + 5.216
    },
    {
        from: (2 * 60) + 5.216,
        to: (2 * 60) + 32.571
    },
    {
        from: (2 * 60) + 32.571,
        to: (4 * 60) + 33
    }
    ],
    musicLoops: 
        [{  
            from: (0 * 60) + 10.857,
            from: (0 * 60) + 10.902,
            from: (0 * 60) + 10.910,
            to: (0 * 60) + 13.160,
            /* to: (0 * 60) + 13.162 */
            /* to: (0 * 60) + 13.194 */
        },
        {
            from: (0 * 60) + 39.440,
            from: (0 * 60) + 39.476,
            to: (0 * 60) + 41.720
        },
        {
            from: (1 * 60) + 4.840,
            from: (1 * 60) + 4.950,
            to: (1 * 60) + 9.440
        },
        {
            from: (1 * 60) + 50.560,
            to: (2 * 60) + 4.280,
            from: (1 * 60) + 50.553,
            to: (2 * 60) + 4.288,
            from: (1 * 60) + 50.282,
            to: (2 * 60) + 3.966
        },
        {
            from: (2 * 60) + 5.216,
            to: (2 * 60) + 32.571
        },
        {
            from: (2 * 60) + 32.571,
            to: (4 * 60) + 33
        }
        ],
    _imgMaskAnimation: [],
    
    loaderRotate: 0,
    loadedElements: 0,
    elementsToLoad: 0,
    showClickableStarsAfter: 3, /* seconds */

    setDimensions: function(){
        game.canvasWidth = window.innerWidth;
        game.canvasHeight = window.innerHeight;
        document.getElementById('canvas').width = game.canvasWidth;
        document.getElementById('canvas').height = game.canvasHeight;
    },

    loadAssets: function(){

        game.showLoader = true;

        game._imgBackground = [];

        game._imgStar1 = new Image();
        game._imgStar2 = new Image();
        game._imgStar3 = new Image();
        game._imgStar4 = new Image();
        game._imgStar5 = new Image();
        game._imgStar6 = new Image();
        game._imgGoodStar = new Image();
        game._imgBadStar = new Image();
        game._imgBackground[1] = new Image();
        game._imgBackground[2] = new Image();
        game._imgBackground[3] = new Image();
        game._imgBackground[4] = new Image();
        game._imgBackground[5] = new Image();
        game._imgBackground[6] = new Image();
        game._imgBackground[7] = new Image();
        game._imgBackground[8] = new Image();
        game._imgBackground[9] = new Image();
        
        game._imgMainTitle = new Image();
        game._imgPlayWithHeadPhones = new Image();
        game._imgTapToStart = new Image();
        game._imgGoForTheRecord = new Image();
        game._imgMaskGlow = new Image();
        game._imgYourScore = new Image();
        game._imgBestScore = new Image();
        game._imgLogoEnd = new Image();
        game._imgTapToStartAgain = new Image();
        game._imgGreenLevelDot = new Image();
        game._imgWhiteLevelDot = new Image();
        game._imgSeparator = new Image();

        game._imgStar1.src = 'i/star-1.png';
        ++game.elementsToLoad === true;
        game._imgStar2.src = 'i/star-2.png';
        ++game.elementsToLoad === true;
        game._imgStar3.src = 'i/star-3.png';
        ++game.elementsToLoad === true;
        game._imgStar4.src = 'i/star-4.png';
        ++game.elementsToLoad === true;
        game._imgStar5.src = 'i/star-5.png';
        ++game.elementsToLoad === true;
        game._imgStar6.src = 'i/star-6.png';
        ++game.elementsToLoad === true;
        game._imgGoodStar.src = 'i/good-star.png';
        ++game.elementsToLoad === true;
        game._imgBadStar.src = 'i/bad-star.png';
        ++game.elementsToLoad === true;
        game._imgBackground[1].src = 'i/backgrounds/1.jpg';
        ++game.elementsToLoad === true;
        game._imgBackground[2].src = 'i/backgrounds/2.jpg';
        ++game.elementsToLoad === true;
        game._imgBackground[3].src = 'i/backgrounds/3.jpg';
        ++game.elementsToLoad === true;
        game._imgBackground[4].src = 'i/backgrounds/4.jpg';
        ++game.elementsToLoad === true;
        game._imgBackground[5].src = 'i/backgrounds/5.jpg';
        ++game.elementsToLoad === true;
        game._imgBackground[6].src = 'i/backgrounds/6.jpg';
        ++game.elementsToLoad === true;
        game._imgBackground[7].src = 'i/backgrounds/7.jpg';
        ++game.elementsToLoad === true;
        game._imgBackground[8].src = 'i/backgrounds/8.jpg';
        ++game.elementsToLoad === true;
        game._imgBackground[9].src = 'i/backgrounds/8.jpg';
        ++game.elementsToLoad === true;
        game._imgMainTitle.src = 'i/main-title.png';
        ++game.elementsToLoad === true;
        game._imgPlayWithHeadPhones.src = 'i/play-with-headphones.png';
        ++game.elementsToLoad === true;
        game._imgTapToStart.src = 'i/tap-to-start2.png';
        ++game.elementsToLoad === true;
        game._imgGoForTheRecord.src = 'i/go-for-the-record.png';
        ++game.elementsToLoad === true;
        game._imgMaskGlow.src = 'i/mask-glow.png';
        ++game.elementsToLoad === true;
        game._imgYourScore.src = 'i/your-score.png';
        ++game.elementsToLoad === true;
        game._imgBestScore.src = 'i/best-score.png';
        ++game.elementsToLoad === true;
        game._imgLogoEnd.src = 'i/logo-end.png';
        ++game.elementsToLoad === true;
        game._imgTapToStartAgain.src = 'i/tap-to-start-again.png';
        ++game.elementsToLoad === true;
        game._imgGreenLevelDot.src = 'i/green-level-dot.png';
        ++game.elementsToLoad === true;
        game._imgWhiteLevelDot.src = 'i/white-level-dot.png';
        ++game.elementsToLoad === true;
        game._imgSeparator.src = 'i/separator.png';
        ++game.elementsToLoad === true;
        
        game.checkIsLoaded(game._imgStar1);
        game.checkIsLoaded(game._imgStar2);
        game.checkIsLoaded(game._imgStar3);
        game.checkIsLoaded(game._imgStar4);
        game.checkIsLoaded(game._imgStar5);
        game.checkIsLoaded(game._imgStar6);
        game.checkIsLoaded(game._imgGoodStar);
        game.checkIsLoaded(game._imgBadStar);
        game.checkIsLoaded(game._imgBackground[1]);
        game.checkIsLoaded(game._imgBackground[2]);
        game.checkIsLoaded(game._imgBackground[3]);
        game.checkIsLoaded(game._imgBackground[4]);
        game.checkIsLoaded(game._imgBackground[5]);
        game.checkIsLoaded(game._imgBackground[6]);
        game.checkIsLoaded(game._imgBackground[7]);
        game.checkIsLoaded(game._imgBackground[8]);
        game.checkIsLoaded(game._imgBackground[9]);
        game.checkIsLoaded(game._imgMainTitle);
        game.checkIsLoaded(game._imgPlayWithHeadPhones);
        game.checkIsLoaded(game._imgTapToStart);
        game.checkIsLoaded(game._imgGoForTheRecord);
        game.checkIsLoaded(game._imgMaskGlow);
        game.checkIsLoaded(game._imgYourScore);
        game.checkIsLoaded(game._imgBestScore);
        game.checkIsLoaded(game._imgLogoEnd);
        game.checkIsLoaded(game._imgTapToStartAgain);
        game.checkIsLoaded(game._imgGreenLevelDot);
        game.checkIsLoaded(game._imgWhiteLevelDot);
        game.checkIsLoaded(game._imgSeparator);
        
        /*
        for(var x = 0, y = 0; x < 811; x += 2){
            ++y;
            
            var newImg = 'i/mask/mask_animation_' + (x + 1) + '.png';
            game._imgMaskAnimation[y] = new Image();
            game._imgMaskAnimation[y].src = newImg;
            game.checkIsLoaded(game._imgMaskAnimation[y]);
            ++game.elementsToLoad === true;

            ++game.maskAnimationFrames === true;
        }
        */
        
        var newImg = 'i/mask/mask_animation_811.png';
        game._imgMaskAnimation = new Image();
        game._imgMaskAnimation.src = newImg;
        game.checkIsLoaded(game._imgMaskAnimation);
        ++game.elementsToLoad === true;
    },

    showGoForTheRecord: function(){
        if(true !== game.goForTheRecordIsStarted){
            game.particles = [];
            for(k = 0; k < 50; ++k === true) {
                game.particles.push(new game.createParticles(game.canvasWidth / 2, game.canvasHeight / 2, Math.floor(Math.random() * 3) - 1.5, '#767676'));
            }

            setTimeout(function(){
                game.goForTheRecordIsStarted = false;
                for(k = 0; k < 50; ++k === true) {
                    game.particles.push(new game.createParticles(game.canvasWidth / 2, game.canvasHeight / 2, Math.floor(Math.random() * 3) - 1.5, '#b7b7b7'));
                }
                game.goForTheRecordIsStarted = true;
            }, 300);

            setTimeout(function(){
                game.goForTheRecordIsStarted = false;
                for(k = 0; k < 50; ++k === true) {
                    game.particles.push(new game.createParticles(game.canvasWidth / 2, game.canvasHeight / 2, Math.floor(Math.random() * 3) - 1.5, '#fff'));
                }
                game.goForTheRecordIsStarted = true;
            }, 600);

            setTimeout(function(){
                game.goForTheRecordVector = -1;
            }, 2000);

            game.goForTheRecordIsStarted = true;
        }

        if(false === game.canShowGoForTheRecord){
            return false;
        }

        game.goForTheRecordOpacity += 0.01 * game.goForTheRecordVector;

        if(game.goForTheRecordOpacity > 1){
            game.goForTheRecordOpacity = 1;
        }

        if(game.goForTheRecordOpacity < 0){
            game.canShowGoForTheRecord = false;
            return false;
        }

        game.ctx.globalAlpha = game.goForTheRecordOpacity;
        game.ctx.drawImage(game._imgGoForTheRecord, (game.canvasWidth / 2) - (354 / 2), (game.canvasHeight / 2) - (20 / 2));
        game.ctx.globalAlpha = 1;
    },

    showMaskAnimation: function(){
        if(game.animatedStars.length > 0){
            // return false;
        }

        if(game.maskSizePercent < 100){
            game.maskSizePercent += game.maskSizePercentIncreaser;
            game.maskSizePercentIncreaser += 0.0001 * (game.maskSizePercentVector);

            if(game.maskSizePercentIncreaser > 1 && 1 === game.maskSizePercentVector){
                game.maskSizePercentIncreaser = 1;
            }

            if(game.maskSizePercentIncreaser < .1 && -1 === game.maskSizePercentVector){
                game.maskSizePercentIncreaser = .1;
            }

            if(game.maskSizePercent > 50 && 1 === game.maskSizePercentVector){
                game.maskSizePercentVector = -1;
            }
        }

        if(game.maskSizePercent >= 104){
            game.maskSizePercent = 104;
        }

        if(game.maskSizePercent >= 98){
            game.maskGlowOpacity += 0.002;
            if(game.maskGlowOpacity > 1){
                game.maskGlowOpacity = 1;
            }

            game.ctx.globalAlpha = game.maskGlowOpacity;
            game.ctx.drawImage(game._imgMaskGlow, (game.canvasWidth / 2) - (264 / 2), (game.canvasHeight / 2) - (207 / 2));
        }

        game.ctx.globalAlpha = 1;

        var maskWidth   = ((390 * game.maskSizePercent) / 100);
        var maskHeight  = ((220 * game.maskSizePercent) / 100);
        game.ctx.drawImage(
            game._imgMaskAnimation, 
            (game.canvasWidth / 2) - (maskWidth / 2),
            (game.canvasHeight / 2) - (maskHeight / 2),
            maskWidth,
            maskHeight
        );

        /* game.ctx.drawImage(
            game._imgMaskAnimation[game.maskAnimationFrames - 1], 
            (game.canvasWidth / 2) - (maskWidth / 2),
            (game.canvasHeight / 2) - (maskHeight / 2),
            maskWidth,
            maskHeight
        ); */
    },

    init: function(){
        game._sndMusic = new Audio('s/TFTC.ogg');
        game._sndMusic.addEventListener('canplaythrough', function(){
            if(true === this.loaded){
                return false;
            }
            this.loaded = true;
        }, false);
        
        game._sndBoom = new Audio('s/boom.ogg');
        
        game.canvas = document.createElement('canvas');
        game.canvas.setAttribute('id', 'canvas');
        document.body.appendChild(game.canvas);
        game.ctx = game.canvas.getContext("2d");

        window.addEventListener("resize", game.setDimensions, false);
        game.setDimensions();

        game.FPS = 60;
        game.frameLimiterNow;
        game.frameLimiterThen = Date.now();
        game.frameLimiterInterval = 1000 / game.FPS;
        game.frameLimiterDelta;

        game.canvas.setAttribute("tabindex", 0);
        game.canvas.focus();
        game.canvas.addEventListener("mousedown", game.getPosition, false);
        game.canvas.addEventListener("touchstart", game.getPosition, false);

        game._imgLoader = new Image();
        game._imgLoader.src = 'i/loader.png';
        game._imgLoader.addEventListener('load', game.loadAssets, false);
        
        game.startConfig();
        game.action();
    },
    startGame: function(){
        game._sndMusic.currentTime = game.musicParts[game.level - 1].from;
        game._sndMusic.currentTime = 0.0;
        game._sndMusic.play();
        
        game.musicTimeout = setTimeout(function(){
            // game.loopMusic();
        }, (game.musicLoops[game.level - 1].to * 1000));
        
        setInterval(function(){
            game.loopMusic2();
        }, .1);
        
        setTimeout(function(){
            game.canShowClickableStars = true;
        }, game.showClickableStarsAfter * 1000);

        game.isStarted = true;
    },
    getPosition: function(e){
        if(game.loaderSeconds < game.maxLoaderSeconds){
            return false;
        }

        if(game.maskLevel === game.level){
            return false;
        }

        if(game.lastLevel === game.level && true !== game.canOverGame){
            return false;
        }

        if(true === game.isOver){
            var rect = game.canvas.getBoundingClientRect();

            if(undefined !== e.touches){
                x = e.touches[0].pageX;
                y = e.touches[0].pageY;
            } else {
                x = e.clientX;
                y = e.clientY;
            }

            x = (x - rect.left) / (game.canvas.clientWidth / game.canvas.width);
            y = (y - rect.top) / (game.canvas.clientHeight / game.canvas.height);

            x = Math.ceil(x);
            y = Math.ceil(y);
            
            if(x >= (game.canvasWidth / 2) - ((498 / 2) / 2) && x <= (game.canvasWidth / 2) + ((498 / 2) / 2) && y >= (game.canvasHeight) - (276 / 2)){
                game.startConfig();
                game.startGame();
            }
            return false;
        }

        if(game.lastLevel === game.level && true === game.canOverGame){
            game.isOver = true;
            game.particles = [];
            game._sndBoom.play();
            for(k = 0; k < 50; ++k === true) {
                game.particles.push(new game.createParticles(game.canvasWidth / 2, game.canvasHeight / 2, Math.floor(Math.random() * 1) - .5, '#fff'));
            }

            for(k = 0; k < 50; ++k === true) {
                game.particles.push(new game.createParticles(game.canvasWidth / 2, game.canvasHeight / 2, Math.floor(Math.random() * 1) - .5, '#3befa4'));
            }

            setTimeout(function(){
                for(k = 0; k < 50; ++k === true) {
                    game.particles.push(new game.createParticles(game.canvasWidth / 2, game.canvasHeight / 2, Math.floor(Math.random() * 1) - .5, '#fff'));
                }

                for(k = 0; k < 50; ++k === true) {
                    game.particles.push(new game.createParticles(game.canvasWidth / 2, game.canvasHeight / 2, Math.floor(Math.random() * 1) - .5, '#3befa4'));
                }
            }, 400);

            return false;
        }

        if(false === game.isStarted){
            game.startGame();
            return false;
        }

        var x, y;
        var rect = game.canvas.getBoundingClientRect();

        if(undefined !== e.touches){
            x = e.touches[0].pageX;
            y = e.touches[0].pageY;
        } else {
            x = e.clientX;
            y = e.clientY;
        }

        x = (x - rect.left) / (game.canvas.clientWidth / game.canvas.width);
        y = (y - rect.top) / (game.canvas.clientHeight / game.canvas.height);

        x = Math.ceil(x);
        y = Math.ceil(y);

        var star = '', k;
        for(var i in game.animatedStars){
            star = game.animatedStars[i], k = 0;
            if(true === star.clickable){
                if(x >= star.x && x <= (star.x + star.width) && y >= star.y && y <= (star.y + star.height)){
                    game.countPoints(star.pointsForMe);
                    /* game.showPoints(); */

                    /* game.animatedStars[i].dy = Math.floor(Math.random() * (-5)) - 10;
                    game.animatedStars[i].dx = Math.floor(Math.random() * (15)) - 10; */
                    game.animatedStars[i].falling = true;
                    game.animatedStars[i].clickable = false;
                    game.animatedStars[i].opacity = 1;
                    /* game.animatedStars.splice(i, 1); */

                    delete k, star, i, x, y;
                    return false;
                }
            }
        }
        delete k, star, i, x, y, rect;
        return false;
    },

    createParticles: function(x, y, m, color) {
        this.x = x || 0;
        this.y = y || 0;

        this.radius = Math.random() * 3;
        var vx = -4;
        if(1 === game.level || (game.goForTheRecordLevel === game.level && true !== game.goForTheRecordIsStarted) || game.lastLevel === game.level){
            vx = -2;
        }

        this.vx = vx + Math.random() * 4;
        this.vy = m * Math.random() * 3;
        this.color = color;
    },

    emitParticles: function(){
        var par,
        maxJ = game.particles.length;
        if(maxJ > 1000){
            game.particles = [];
        }

        for(var j = 0; j < maxJ; ++j === true) {
            par = game.particles[j];
            if(undefined === par){
                return false;
            }

            if (par.radius <= 0) {
                continue;
            } else {
                game.ctx.globalAlpha = Math.random();
                game.ctx.beginPath();
                game.ctx.fillStyle = par.color;

                game.ctx.arc(par.x, par.y, par.radius, 0, Math.PI*2, false);
                game.ctx.fill();	 

                par.x += par.vx; 
                par.y += par.vy; 

                /* Reduce radius so that the particles die after a few seconds */
                par.radius = Math.max(par.radius - 0.03, 0.0); 
                game.ctx.closePath();
                game.ctx.globalAlpha = 1;
            }
        }
        
        delete j, maxJ, par;
    },

    lastStar: function(){
        if(true === game.isOver){
            game.ctx.drawImage(game._imgBestScore, (game.canvasWidth - 30 - (178 / 2)), 22, 178 / 2, 120 / 2);
            game.ctx.drawImage(game._imgYourScore, (game.canvasWidth / 2) - ((178 / 2) / 2), 26, 178 / 2, 120 / 2);
            game.ctx.drawImage(game._imgLogoEnd, 30, 30, 208 / 2, 70 / 2);
            game.ctx.drawImage(game._imgTapToStartAgain, (game.canvasWidth / 2) - ((498 / 2) / 2), (game.canvasHeight) - (276 / 2), 498 / 2, 276 / 2);
            
            var highScore = localStorage._BokkaHighScore;
            if('' === highScore || undefined === highScore || highScore < game.sumOfPoints){
                localStorage._BokkaHighScore = game.sumOfPoints;
                highScore = game.sumOfPoints;
            }
            
            game.ctx.font = "bold 60px Arial";
            game.ctx.textAlign = 'center';
            game.ctx.fillStyle = "#57e8bd";
            game.ctx.fillText(game.sumOfPoints, game.canvasWidth / 2, (game.canvasHeight / 2) + 10);
            
            game.ctx.font = "bold 32px Arial";
            game.ctx.fillText(highScore, (game.canvasWidth - 30 - ((178 / 2) /2)), (game.canvasHeight / 2));
            /* game.ctx.fillText('High score: ' + highScore, game.canvasWidth / 2, (game.canvasHeight / 2) + 15); */
            return false;
        }

        if(true !== game.lastStarIsStarted){
            setTimeout(function(){
                game.canShowLastStar = true;
            }, 3000);
            game.lastStarIsStarted = true;
        }

        if(true === game.canShowLastStar){
            var width = 188;
            var height = width;
            game.ctx.globalAlpha = game.lastStarOpacity;
            game.lastStarOpacity += .040;
            if(game.lastStarOpacity > 1){
                game.lastStarOpacity = 1;
                game.canOverGame = true;
            }
            game.ctx.drawImage(game._imgGoodStar, (game.canvasWidth / 2) - (width / 2), (game.canvasHeight / 2) - (height / 2), width, height);
            game.ctx.globalAlpha = 1;
            
            delete width, height;
        }
    },
    
    loopMusic2: function(){
        var musicCurrentTime = Number(game._sndMusic.currentTime) / 1000000;
        /* var musicCurrentTime = Number(game._sndMusic.currentTime); */
        
        /* game.ctx.font = "20px Arial";
        game.ctx.textAlign = 'left';
        game.ctx.fillStyle = "#fff";
        game.ctx.fillText('m' + musicCurrentTime, 30, 30);
        console.log(musicCurrentTime * 1000000); */
        if(game.goForTheRecordLevel === game.level){
            if(musicCurrentTime >= game.musicParts[game.level - 1].to){
                ++game.level;
                game.backgroundOpacity = 0;
                game.points = 0;
            }
            return false;
        }

        if(game.points >= game.starsPerLevel[game.level - 1]){
            if(musicCurrentTime >= game.musicParts[game.level].from){
                ++game.level;
                game.backgroundOpacity = 0;
                game.points = 0;
            }
            
            // setTimeout(function(){
              //  game.loopMusic();
            // }, ((game.musicLoops[game.level].to * 1000) - (game.musicLoops[game.level - 1].to * 1000)));
            
            return false;
        }

        if(game.level < game.maskLevel){
            if(game.points < game.starsPerLevel[game.level - 1]){
                if(musicCurrentTime >= game.musicLoops[game.level - 1].to){
                    /* game._sndMusic.volume = 0; */
                    game._sndMusic.currentTime = game.musicLoops[game.level - 1].from;
                    /* game._sndMusic.volume = 1; */
                    game.musicWasLooped = true;
                }
            }
        }
        return false;
    },
    
    loopMusic: function(){
        return false;
        if(game.goForTheRecordLevel === game.level){
            setTimeout(function(){
                game.level = game.lastLevel;
                game.lastStar();
            }, 1);
            return false;
        }

        if(game.points >= game.starsPerLevel[game.level - 1]){
            setTimeout(function(){
                ++game.level;
                game.backgroundOpacity = 0;
                game.points = 0;
            }, ((game.musicParts[game.level].from * 1000) - (game.musicLoops[game.level - 1].to * 1000)));
            
            setTimeout(function(){
                game.loopMusic();
            }, ((game.musicLoops[game.level].to * 1000) - (game.musicLoops[game.level - 1].to * 1000)));
            
            return false;
        }

        if(game.level < game.maskLevel){
            if(game.points < game.starsPerLevel[game.level - 1]){
                game._sndMusic.volume = 0;
                game._sndMusic.currentTime = game.musicLoops[game.level - 1].from;
                game._sndMusic.volume = 1;
                game.musicWasLooped = true;

                game.musicTimeout = setTimeout(function(){
                    game.loopMusic();
                }, ((game.musicLoops[game.level - 1].to * 1000) - (game.musicLoops[game.level - 1].from * 1000)));
            }
        }
        return false;
    },
    
    action: function(){
        requestAnimationFrame(game.action);
        
        game.frameLimiterNow = Date.now();
        game.frameLimiterDelta = game.frameLimiterNow - game.frameLimiterThen;

        if(game.frameLimiterDelta < game.frameLimiterInterval){
            return false;
        }
        
        game.ctx.fillStyle = '#000';
        game.ctx.fillRect(0, 0, game.canvasWidth, game.canvasHeight);
        /* game.ctx.clearRect(0, 0, game.canvasWidth, game.canvasHeight); */
        /* game.ctx.drawImage(game._imgBackground, 0, 0, 667, 375); */

        game.ctx.globalAlpha = 1;

        if(game.level > 1){
            if(game.backgroundOpacity < 1){
                game.ctx.drawImage(game._imgBackground[game.level - 1], 0, -(750 - game.canvasHeight));
            }
            
            if(game.backgroundOpacity < 1){
                game.ctx.globalAlpha = game.backgroundOpacity;
                game.backgroundOpacity += 0.02;
            }
            
            if(game.backgroundOpacity > 1){
                game.backgroundOpacity = 1;
            }

            game.ctx.drawImage(game._imgBackground[game.level], 0, -(750 - game.canvasHeight));

        } else {
            game.ctx.drawImage(game._imgBackground[1], 0, -(750 - game.canvasHeight));
        }

        game.ctx.globalAlpha = 1;

        if(true === game.isStarted){
            game.starsParallax();
            game.showPoints();
            game.emitParticles();
        }

        game.startScreen();
        game.frameLimiterThen = game.frameLimiterNow - (game.frameLimiterDelta % game.frameLimiterInterval);

    },

    checkIsLoaded: function(img){
        ++game.loadedElements === true;
        return true;
        if (undefined === img /* || 0 === img.width */) {
            setTimeout(function(){
                game.checkIsLoaded(arguments[0]); 
            }, 500, img);
            return false;
        }
    },
    
    startScreen: function(){
        
        /* cause coocon js have problems with preloading images, we used the false preloader - we are showing it for few seconds for sure that images are loaded */
        
        if(Math.random() > .6){
            game.loaderSeconds += 1;
        }
        
        if(Math.random() > .9){
            game.loaderSeconds += 1;
        }
        
        if(game.loaderSeconds > game.maxLoaderSeconds){
            game.loaderSeconds = game.maxLoaderSeconds;
        }
        
        if(game.loaderSeconds < game.maxLoaderSeconds || game._sndMusic.loaded !== true){
            if(true === game.showLoader){
                game.loaderRotate += .1;
                if(game.loaderRotate > 360){
                    game.loaderRotate = 0;
                }
                game.ctx.save();
                game.ctx.translate(game.canvasWidth / 2, game.canvasHeight / 2);
                game.ctx.rotate(game.loaderRotate);
                game.ctx.drawImage(game._imgLoader, Math.floor(-(132 / 2)), Math.floor( - (133 / 2)), 132, 133);
                game.ctx.restore();

                var percent = Math.floor((game.loaderSeconds * 100) / 500);
                game.ctx.font = "20px Arial";
                game.ctx.textAlign = 'center';
                game.ctx.fillStyle = "#fff";
                game.ctx.fillText(percent + '%', game.canvasWidth / 2, (game.canvasHeight / 2) + 5);
                delete percent;
            }
            
            return false;
        }

        if(game.loaderSeconds >= game.maxLoaderSeconds){
            game.loaderSeconds = game.maxLoaderSeconds;
            if(game.mainScreenOpacity <= 0 && true === game.isStarted){
                return false;
            }

            game.ctx.globalAlpha = game.mainScreenOpacity;

            game.ctx.drawImage(game._imgPlayWithHeadPhones, Math.floor((game.canvasWidth / 2) - ((436 / 2) / 2)), 10, 436 / 2, 90 / 2);        
            game.ctx.drawImage(game._imgTapToStart, Math.floor((game.canvasWidth / 2) - ((390 / 2) / 2)), Math.floor(game.canvasHeight - ((280 / 2))), 390 / 2, 280 / 2);
            game.ctx.drawImage(game._imgMainTitle, Math.floor((game.canvasWidth / 2) - ((608 / 2) / 2)) + 20, Math.floor((game.canvasHeight / 2) - ((250 / 2) / 2)), 608 / 2, 250 / 2);
            
            if(game.mainScreenOpacity < 1 && false === game.isStarted){
                game.mainScreenOpacity += .01;
            }
            if(game.mainScreenOpacity > 1){
                game.mainScreenOpacity = 1;
            }
            if(game.mainScreenOpacity > 0 && true === game.isStarted){
                game.mainScreenOpacity -= .04;
            }

            if(game.mainScreenOpacity < 0){
                game.mainScreenOpacity = 0;
            }
            game.ctx.globalAplha = 1;
        }
    },

    drawParallax: function(){
        var i = 0, k = 0, j = 0;
            
        for(i in game.animatedStars){
            if(true === game.animatedStars[i].is_deleted){
                game.animatedStars.splice(i, 1);
                // --i === true;
            }
        }
            
        for(i in game.animatedStars){
                
            //if(1 !== game.level && game.maskLevel !== game.level){
                game.animatedStars[i].x -= game.animatedStars[i].dx;
                // game.animatedStars[i].y += game.animatedStars[i].dy;
                
                /* gwiazdki uciekają jeśli kosmos ma zostać pusty */
                
                if(game.lastLevel === game.level){
                    game.animatedStars[i].dx += .08;
                }
                
                if(game.maskLevel === game.level){
                    if(game.animatedStars[i].dx > 0){
                        // console.log(game.animatedStars[i].dx);
                        game.animatedStars[i].dx -= .02;
                        if(game.animatedStars[i].dx < 0){
                            game.animatedStars[i].dx = 0;
                        }
                    }
                }
                
                /* gwiazdki ruszają z kosmosu stojącego w miejscu */
                if((2 === game.level || game.goForTheRecordLevel === game.level)){
                    if(game.animatedStars[i].dx < game.animatedStars[i].maxdx){
                        game.animatedStars[i].dx += .06;
                        if(game.animatedStars[i].dx > game.animatedStars[i].maxdx){
                            game.animatedStars[i].dx = game.animatedStars[i].maxdx;
                        }
                    }
                }
            //}

            if(game.animatedStars[i].x < -game.animatedStars[i].width){
                game.animatedStars[i].is_deleted = true;
                /* --i === true; */
                continue;
            }

            if((true === game.animatedStars[i].clickable) || 1 === game.level || game.maskLevel === game.level){
                if(game.animatedStars[i].opacity < 1 && game.animatedStars[i].livingTime > 0){
                    game.animatedStars[i].opacity += .01;
                }

                if(game.animatedStars[i].opacity > 1){
                    game.animatedStars[i].opacity = 1;
                }

                if(game.animatedStars[i].livingTime >= 0){
                    game.animatedStars[i].livingTime -= 1;
                }

                if(game.animatedStars[i].livingTime <= 0){
                    game.animatedStars[i].opacity -= .01;
                }

                if(game.animatedStars[i].opacity < 0){
                    game.animatedStars[i].opacity = 0;
                }
            }

            game.ctx.globalAlpha = game.animatedStars[i].opacity;

            game.ctx.drawImage(game.animatedStars[i].img, game.animatedStars[i].x, game.animatedStars[i].y, Math.floor(game.animatedStars[i].width), Math.floor(game.animatedStars[i].height));

            game.ctx.globalAlpha = 1;

            if(game.animatedStars[i].opacity <= 0 && game.animatedStars[i].livingTime <= 0){
                /* if(0 < game.animatedStars[i].pointsForMe){
                    if(game.points < game.starsPerLevel[game.level - 1]){
                        --game.points === true;
                        if(game.points < 0){
                            game.points = 0;
                        }
                    }
                } */

                game.animatedStars[i].is_deleted = true;

                /* --i === true; */
                continue;
            }

            if(true === game.animatedStars[i].falling){
                /* game.ctx.globalAlpha = game.animatedStars[i].opacity; */
                game.animatedStars[i].width += game.animatedStars[i].blow;
                game.animatedStars[i].height += game.animatedStars[i].blow;

                game.animatedStars[i].y -= game.animatedStars[i].blow / 2;
                game.animatedStars[i].x -= game.animatedStars[i].blow / 2;

                if(1 !== game.level){
                    game.animatedStars[i].blow += .4;
                }

                game.animatedStars[i].dx *= .96;
                /* game.animatedStars[i].dy += .6; */
                game.animatedStars[i].opacity -= .04;

                for(k = 0; k < 1; ++k === true) {
                    game.particles.push(new game.createParticles((game.animatedStars[i].x + ((game.animatedStars[i].width) / 2)), (game.animatedStars[i].y + ((game.animatedStars[i].height) / 2)), Math.floor(Math.random() * 1) - .5, game.animatedStars[i].myStroke));
                }

                for(k = 0; k < 1; ++k === true) {
                    game.particles.push(new game.createParticles((game.animatedStars[i].x + ((game.animatedStars[i].width) / 2)), (game.animatedStars[i].y + ((game.animatedStars[i].height) / 2)), Math.floor(Math.random() * 1) - .5, '#fff'));
                }

                if(game.animatedStars[i].opacity <= 0){

                    for(k = 0; k < 10; ++k === true) {
                        game.particles.push(new game.createParticles((game.animatedStars[i].x + ((game.animatedStars[i].width) / 2)), (game.animatedStars[i].y + ((game.animatedStars[i].height) / 2)), Math.floor(Math.random() * 2) - .6, game.animatedStars[i].myStroke));
                    }

                    for(k = 0; k < 10; ++k === true) {
                        game.particles.push(new game.createParticles((game.animatedStars[i].x + ((game.animatedStars[i].width) / 2)), (game.animatedStars[i].y + ((game.animatedStars[i].height) / 2)), Math.floor(Math.random() * 2) - .6, '#fff'));
                    }

                    game.animatedStars[i].is_deleted = true;
                    /* --i === true; */
                }
            }
        }
        delete i, k;
    },

    createStars: function(){
        if(Math.random() > .80 - (game.level / 10)){
            var layer = Math.ceil(Math.random() * 5);
            var x = game.canvasWidth;
            var y = Math.floor(Math.random() * game.canvasHeight);
            var img = '', maxdx = 0, dx = 0, dy = 0, width = 0, height = 0, clickable = false, myStroke = '', pointsForMe = 0, opacity = 1, livingTime = 400 + Math.floor(Math.random() * 100);

            if(5 !== layer){
                if(game.animatedStars.length > 70){
                    return false;
                }
            }

            if(1 === layer){
                img = game._imgStar1;
                dx = 1;
                width = 2;
                height = width;
            }

            if(2 === layer){
                if(Math.random() >= .5){
                    img = game._imgStar3;
                    width = 20;
                } else {
                    img = game._imgStar5;
                    width = 4;
                }
                height = width;
                dx = 2;
            }

            if(3 === layer){
                img = game._imgStar2;
                dx = 3;
                width = Math.floor(Math.random() * 40) + 30;
                height = width;
            }

            if(4 === layer){
                if(Math.random() < .84){
                    return false;
                }

                if(Math.random() >= .5){
                    img = game._imgStar4;
                    width = 155;
                } else {
                    img = game._imgStar6;
                    width = 94;
                }

                dx = 4;
                height = width;
            }

            if(5 === layer){
                if(false === game.canShowClickableStars || game.maskLevel === game.level){
                    return false;
                }
                
                if(Math.random() < .82 - (game.level / 100)){
                    return false;
                }

                img = game._imgStar3;
                dx = Math.floor(Math.random() * 3) + 2;
                width = 188;
                height = width;
                if(Math.random() > .5) {
                    width = Math.floor(width / 2);
                    height = Math.floor(height / 2);
                }
                clickable = true;
                opacity = 0;
                livingTime = Math.floor(Math.random() * 80) + 100;

                x = Math.floor((Math.random() * (game.canvasWidth / 2)) + game.canvasWidth / 2);

                if(Math.random() >= .5 || game.levelWithRedStars > game.level){
                    img = game._imgGoodStar;
                    myStroke = '#3befa4';
                    pointsForMe = 1;
                } else {
                    img = game._imgBadStar;
                    myStroke = '#b21041';
                    pointsForMe = -1;
                }
            }

            if(5 !== layer && 1 !== layer){
                var star = '';
                for(var i in game.animatedStars){
                    star = game.animatedStars[i];
                    if(x >= star.x && x <= star.x + star.width){
                        return false;
                    }
                }
                delete star;
            }
            
            dx += ((game.level - 1) / 2);
            maxdx = dx;
            
            if(1 === game.level || game.maskLevel === game.level){
                x = Math.floor(Math.random() * game.canvasWidth);
                dx = 0;
                opacity = 0;
            }

            if(game.goForTheRecordLevel === game.level){
                dx *= game.goForTheRecordSpeed;
                game.goForTheRecordSpeed += .0004;
                if(game.goForTheRecordSpeed > 16){
                    game.goForTheRecordSpeed = 16;
                }

                if(5 === layer){
                    x = game.canvasWidth;
                }
            }

            if((1 === game.level && 5 === layer)){
                if(x >= game.canvasWidth - 200){
                    x = Math.floor(Math.random() * (game.canvasWidth - 200));
                }
            }

            if(y >= game.canvasHeight - height){
                y = game.canvasHeight - height;
            }
            
            game.animatedStars.push({
                x: x,
                y: y,
                maxdx: maxdx,
                dx: dx,
                dy: 0,
                img: img,
                width: width / 1.4,
                height: height / 1.4,
                clickable: clickable,
                myStroke: myStroke,
                pointsForMe: pointsForMe,
                opacity: opacity,
                layer: layer,
                livingTime: livingTime,
                blow: 1
            });
            
            delete layer, x, y, img, dx, dy, maxdx, opacity, livingTime, pointsForMe, width, height, clickable;
        }
    },

    starsParallax: function(){
        
        game.drawParallax();

        if(game.goForTheRecordLevel === game.level){
            game.showGoForTheRecord();
        }
        
        if(game.maskLevel === game.level){
            game.showMaskAnimation();
        }
        
        if(game.lastLevel === game.level){
            game.lastStar();
            return false;
        }

        game.createStars();
        
        return false;
    },

    countPoints: function(point){
        if(game.points >= game.starsPerLevel[game.level - 1]){
            return false;
        }

        game.points += point;
        if(game.points < 0){
            game.points = 0;
        }

        if(/* point > 0 && */ game.goForTheRecordLevel === game.level){
            game.sumOfPoints += point;
            if(game.sumOfPoints < 0){
                game.sumOfPoints = 0;
            }
        }

        if(game.points > game.starsPerLevel[game.level - 1]){
            game.points = game.starsPerLevel;
        }
    },

    showPoints: function(){
        if(game.maskLevel === game.level || game.lastLevel === game.level){
            return false;
        }

        if(game.goForTheRecordLevel !== game.level){
            for(var x = 0, y = game.starsPerLevel.length; x < y; ++x === true){
                if(game.level > x){
                    game.ctx.drawImage(game._imgGreenLevelDot, game.canvasWidth - 15 - (14 * (y - x)), 16);
                } else {
                    game.ctx.drawImage(game._imgWhiteLevelDot, game.canvasWidth - 15 - (14 * (y - x)), 16);
                }
            }

            game.ctx.font = "bold 40px Arial";
            game.ctx.textAlign = 'right';
            game.ctx.fillStyle = "#38f0a2";
            game.ctx.fillText(game.points, game.canvasWidth - 60, 66);
            game.ctx.font = "bold 20px Arial";
            game.ctx.textAlign = 'left';
            game.ctx.fillStyle = "#fff";
            game.ctx.fillText(game.starsPerLevel[game.level - 1], game.canvasWidth - 40, 54);
            game.ctx.drawImage(game._imgSeparator, game.canvasWidth - 51, 38);
        }

        if(game.goForTheRecordLevel === game.level){
            game.ctx.font = "bold 32px Arial";
            game.ctx.textAlign = 'right';
            game.ctx.fillStyle = "#38f0a2";
            game.ctx.fillText(game.sumOfPoints, game.canvasWidth - 20, 44);
        }
        
        delete x, y;
    }
};

setTimeout(function(){
    game.init();
}, 100);
